
//  ஢,    ࠬ HOB XServer 

// Frame_window -  ࠬ.
BYTE Krnl_Repository_IsHobWindow( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ஢塞 .
   if( strfind( "XWP", Client_name ) ) return 1;
  }

 // .
 return 0;
}

//  ஢,    ࠡ祩  Java 

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsJavaWindow( HWND Window )
{
 //  ,   । .
 CHAR Window_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Window, SIZE_OF_NAME, Window_name );

 // ஢塞 .
 if( strfind( "awt", Window_name ) )
  if( strfind( "Class", Window_name ) ) return 1;

 // .
 return 0;
}

//  ஢,       

// Frame_window -  ࠬ.
BYTE Krnl_Repository_WindowIsDialog( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 // ᫨   אַ㣮쭨 - ⠥,  ⠪  .
 if( Client_window != NULLHANDLE ) if( IsStaticWindow( Client_window ) ) Client_window = NULLHANDLE;

 // ᫨  ࠡ祩  :
 if( Client_window == NULLHANDLE )
  {
   // ᫨   ࠬ ﭭ ࠧ -     .
   if( FrameType( Frame_window ) == FT_CONST ) return 1;

   // ᫨    ४ - ⮦.
   if( WinQuerySwitchHandle( Frame_window, NULLHANDLE ) == NULLHANDLE ) return 1;
  }

 // .
 return 0;
}

//  ஢,       ਫ 

// Frame_window -  ࠬ.
BYTE Krnl_Repository_WindowIsAppDialog( HWND Frame_window )
{
 // ᫨     :
 if( Krnl_Repository_WindowIsDialog( Frame_window ) )
  {
   // ᫨   :
   HWND Owner_window = WinQueryWindow( Frame_window, QW_OWNER );

   if( Owner_window != NULLHANDLE ) if( Owner_window != QueryDesktopWindow() )
    if( Owner_window != QueryDesktopWindow() )
     {
      //    ਫ, .
      return 1;
     }
  }

 // .
 return 0;
}

//  ஢, LaunchPad    

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsLaunchPadWindow( HWND Window )
{
 // ᫨  ᮧ  窮 - .
 if( !Repository_IsWorkplaceShellWindow( Window ) ) return 0;

 // ᫨  ᪮ -  LaunchPad.
 if( WinWindowFromID( Window, FID_CLIENT ) == NULLHANDLE )
  if( FrameType( Window ) == FT_FLAT )
   return 1;

 // .
 return 0;
}

//  ஢,    ᯮ, 宦  WarpCenter 

// Window -   ஢ન.
BYTE Krnl_Repository_HasWarpCenterSize( HWND Window )
{
 //  ࠧ .
 RECT Rectangle = { 0, 0, 0, 0 }; WinQueryWindowRect( Window, &Rectangle );

 // ᫨ ਭ   ᪮쪮 ࠧ   :
 if( Rectangle.xRight > Rectangle.yTop * 10 )
  {
   //   ࠡ祣 ⮫.
   HWND Desktop = QueryDesktopWindow();

   //  ࠧ ࠭.
   INT X_Screen = WinQuerySysValue( QueryDesktopWindow(), SV_CXSCREEN );

   // ᫨ ਭ   ࠧ ࠭ -   宦  WarpCenter.
   if( Rectangle.xRight > X_Screen - 10 ) return 1;
  }

 // .
 return 0;
}

//  ஢, WarpCenter    

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsWarpCenterWindow( HWND Window )
{
 // ᫨  ᮧ  窮 - .
 if( !Repository_IsWorkplaceShellWindow( Window ) ) return 0;

 // ᫨ த⥫᪮   ࠡ稩 ⮫ - .
 if( WinQueryWindow( Window, QW_PARENT ) != QueryDesktopWindow() ) return 0;

 //  ,   । .
 CHAR Window_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Window, SIZE_OF_NAME, Window_name );

 // ᫨    WarpCenter:
 if( strcmp( Window_name, "#3" ) == EQUALLY )
  if( Krnl_Repository_HasWarpCenterSize( Window ) )
   {
    //   .
    Window_name[ 0 ] = NULL;
    WinQueryWindowText( Window, SIZE_OF_NAME, Window_name );

    // ᫨  WarpCenter - 頥 1.
    if( strcmp( Window_name, "SmartCenter" ) == EQUALLY ) return 1;
   }

 // .
 return 0;
}

//  ஢,        WarpCenter 

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsWarpCenterMenuWindow( HWND Window )
{
 // ᫨  ᮧ  窮 - .
 if( !Repository_IsWorkplaceShellWindow( Window ) ) return 0;

 // ᫨ த⥫᪮   ࠡ稩 ⮫ - .
 if( WinQueryWindow( Window, QW_PARENT ) != QueryDesktopWindow() ) return 0;

 //  ,   । .
 CHAR Window_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Window, SIZE_OF_NAME, Window_name );

 // ᫨    WarpCenter:
 if( strcmp( Window_name, "#3" ) == EQUALLY )
  {
   //  ࠧ .
   RECT Rectangle = { 0, 0, 0, 0 }; WinQueryWindowRect( Window, &Rectangle );

   // ᫨     ਭ -   WarpCenter.
   if( Rectangle.yTop > Rectangle.xRight ) return 1;
  }

 // .
 return 0;
}

//  ஢, SysTray    

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsSysTrayWindow( HWND Window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ᫨     SysTray:
   if( strifind( "SysTray", Client_name ) )
    {
     // ஢塞 ᯮ .
     if( Krnl_Repository_HasWarpCenterSize( Window ) ) return 1;
    }
  }

 // .
 return 0;
}

//  ஢,        SysTray 

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsSysTrayMenuWindow( HWND Window )
{
 // ᫨   :
 if( IsMenuWindow( Window ) )
  {
   //   .
   HWND Owner_window = WinQueryWindow( Window, QW_OWNER );

   //  ,   । .
   CHAR Owner_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Owner_window, SIZE_OF_NAME, Owner_name );

   // ஢塞 .
   if( strcmp( Owner_name, "AgentCenterClass" ) == EQUALLY ) return 1;
   if( strcmp( Owner_name, "SPLG_WarpButton" ) == EQUALLY ) return 1;
  }

 // .
 return 0;
}

//  ஢, XCenter    

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsXCenterWindow( HWND Window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ᫨     XCenter:
   if( strifind( "XWPCenter", Client_name ) )
    {
     // ஢塞 ᯮ .
     if( Krnl_Repository_HasWarpCenterSize( Window ) ) return 1;
    }
  }

 // .
 return 0;
}

//  ஢,        XCenter 

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsXCenterMenuWindow( HWND Window )
{
 // ᫨   :
 if( IsMenuWindow( Window ) )
  {
   //   .
   HWND Owner_window = WinQueryWindow( Window, QW_OWNER );

   //  ,   । .
   CHAR Owner_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Owner_window, SIZE_OF_NAME, Owner_name );

   // ஢塞 .
   if( strifind( "XWPCenter", Owner_name ) ) return 1;
  }

 // .
 return 0;
}

//  ஢,    ன 梥⮢  ⮢ 

// Frame_window -   ஢ન.
BYTE Krnl_Repository_IsPaletteWindow( HWND Frame_window )
{
 // ᫨  ᮧ  窮 - .
 if( !Repository_IsWorkplaceShellWindow( Frame_window ) ) return 0;

 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ஢塞 .
   if( strcmp( Client_name, "PaletteClient" ) == EQUALLY ) return 1;
  }

 // .
 return 0;
}

//  ஢,    ᯨ᪮    

// Frame_window -   ஢ન.
BYTE Krnl_Repository_IsJobCnrWindow( HWND Frame_window )
{
 // ᫨  ᮧ  窮 - .
 if( !Repository_IsWorkplaceShellWindow( Frame_window ) ) return 0;

 // ॡࠥ , ᯮ   ࠬ.
 HENUM Enumeration = WinBeginEnumWindows( Frame_window ); HWND Window = NULLHANDLE;
 while( ( Window = WinGetNextWindow( Enumeration ) ) != NULLHANDLE )
  {
   //  ,   । .
   CHAR Window_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Window, SIZE_OF_NAME, Window_name );

   // ஢塞 .
   if( strcmp( Window_name, "JobCnr" ) == EQUALLY )
    {
     // 蠥 ॡ .
     WinEndEnumWindows( Enumeration );

     // .
     return 1;
    }
  }
 WinEndEnumWindows( Enumeration );

 // .
 return 0;
}

//  ஢, SmartBar    

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsSmartBarWindow( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ஢塞 .
   if( strcmp( Client_name, "SMARTBAR_ClientWindow" ) == EQUALLY ) return 1;
  }

 // .
 return 0;
}

//  ஢,      ७  ⥢ ॢ⥫ Mozilla 

// Window - , ஥  ஢.
BYTE Krnl_Repository_IsMozillaLiningWindow( HWND Window )
{
 //  ,   । .
 CHAR Window_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Window, SIZE_OF_NAME, Window_name );

 // ஢塞 .
 if( strcmp( Window_name, "MozillaWindowClass" ) == EQUALLY ) return 1;

 // .
 return 0;
}

//  ஢,       ࠬ Mozilla 

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsMozillaFrameWindow( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   // ஢塞 .
   return Krnl_Repository_IsMozillaLiningWindow( Client_window );
  }

 // .
 return 0;
}

//  ஢,       ᬮ  

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsVideoViewerWindow( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ஢塞 .
   if( strfind( "VIDEO2", Client_name ) ) return 1;
  }

 // .
 return 0;
}

//  ஢,       ᬮ  

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsVideoPlayerWindow( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ஢塞 .
   if( strfind( "diveView", Client_name ) ) return 1;
  }

 // .
 return 0;
}

//  室  ᯨ᪠ ⮢    

// Frame_window - , ஥  ஢.
HWND Krnl_Repository_FindFontListField( HWND Frame_window )
{
 // ॡࠥ    .
 HENUM Enumeration = WinBeginEnumWindows( Frame_window ); HWND Window = NULLHANDLE;
 while( ( Window = WinGetNextWindow( Enumeration ) ) != NULLHANDLE )
  {
   // ᫨  㯭 - த ॡ .
   if( !WindowIsPresent( Window ) ) continue;

   // ᫨   ᯨ᪠:
   if( IsListBoxWindow( Window ) )
    {
     // ஢塞,     ப   ࠧ .
     INT First_line = 0; INT Length = strlen( "## x ##" );
     WinSendMsg( Window, LM_QUERYITEMTEXT, MPFROM2SHORT( First_line, Length ), Krnl_Repository.RTSettings.Item_text );
     CHAR Text[ 25 ] = ""; strncpy( Text, Krnl_Repository.RTSettings.Item_text, Length );

     // ᫨  :
     if( Text[ 2 ] == ' ' && Text[ 3 ] == 'x' && Text[ 4 ] == ' ' )
      {
       // 蠥 ॡ .
       WinEndEnumWindows( Enumeration );

       // ᮪ , .
       return Window;
      }
    }
  }
 WinEndEnumWindows( Enumeration );

 // .
 return NULLHANDLE;
}

//  ஢,      ᬥ   ⥪⮢  

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsVIOFontMetricsDialog( HWND Frame_window )
{
 // ஢塞 .
 if( Krnl_Repository_WindowIsDialog( Frame_window ) )
  if( IsPresentationManagerWindow( Frame_window ) )
   if( Krnl_Repository_FindFontListField( Frame_window ) != NULLHANDLE )
    return 1;

 // .
 return 0;
}

//  ஢, ⥬  ᮮ饭   

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsSysMsgWindow( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ஢塞 .
   if( strcmp( Client_name, "PM Hard Error" ) == EQUALLY ) return 1;
  }

 // .
 return 0;
}

//  ஢, ᮧ      RZ API 

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsRZApiWindow( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   //  ,   । .
   CHAR Client_name[ SIZE_OF_NAME ] = ""; WinQueryClassName( Client_window, SIZE_OF_NAME, Client_name );

   // ஢塞 .
   if( strcmp( Client_name, "RzFrW" ) == EQUALLY ) return 1;
   if( strifind( "RzSup_", Client_name ) ) return 1;
  }

 // .
 return 0;
}

//  ஢,    ࠬ GoldED 

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsGoldEdWindow( HWND Frame_window )
{
 // ᫨  ⥪⮢ :
 if( Repository_IsVIOWindow( Frame_window ) )
  {
   //   ਫ, ᮧ襣 .
   CHAR Exe_name[ SIZE_OF_NAME ] = ""; GetDetectedExeName( Frame_window, Exe_name );

   // ᫨  㤠 ।:
   if( Exe_name[ 0 ] != 0 )
    {
     // ஢塞 .
     if( strlen( Exe_name ) > 6 )
      {
       Exe_name[ 3 ] = 0; if( stricmpe( Exe_name, "Ged" ) == EQUALLY ) return 1;
      }
    }
  }

 // .
 return 0;
}

//  ஢,    ࠬ HotJava 

// Frame_window - , ஥  ஢.
BYTE Krnl_Repository_IsHotJavaBrowserWindow( HWND Frame_window )
{
 //   ࠡ祩 .
 HWND Client_window = WinWindowFromID( Frame_window, FID_CLIENT );

 if( Client_window != NULLHANDLE )
  {
   // ᫨   Java:
   if( Krnl_Repository_IsJavaWindow( Client_window ) )
    {
     //   .
     CHAR Title[ SIZE_OF_TITLE ] = ""; GetDetectedWindowTitle( Frame_window, Title );

     // ஢塞 .
     if( strifind( "HotJava", Title ) ) return 1;
    }
  }

 // .
 return 0;
}

//  室 宦 , ᯮ ⮤  ࠢ 

// Frame_window -  ਫ, Method - ⮤,  㤥 뢠  ࠢ.
HWND Krnl_Repository_FindRelatedFrameWindow( HWND Frame_window, PISAPPWINDOW Method )
{
 //  । ᮮ饭 .
 HMQ Message_queue = WinQueryWindowULong( Frame_window, QWL_HMQ );

 //   ࠡ祣 ⮫.
 HWND Desktop = QueryDesktopWindow();

 // ॡࠥ    ࠡ祣 ⮫.
 HENUM Enumeration = WinBeginEnumWindows( Desktop ); HWND Window = NULLHANDLE;
 while( ( Window = WinGetNextWindow( Enumeration ) ) != NULLHANDLE )
  {
   // ᫨   ࠬ    믮 㪠 ⮤:
   if( Window != Frame_window ) if( IsFrameWindow( Window ) ) if( Method( Window ) )
    {
     //  । ᮮ饭 .
     HMQ Window_queue = WinQueryWindowULong( Window, QWL_HMQ );

     // ᫨ । ᮢ - 蠥 ॡ .
     if( Window_queue == Message_queue )
      {
       // 蠥 ॡ 
       WinEndEnumWindows( Enumeration );

       // .
       return Window;
      }
    }
  }
 WinEndEnumWindows( Enumeration );

 // .
 return NULLHANDLE;
}

//    ਭ  㬮砭 

// Name - ப  .
VOID Krnl_Repository_QueryPrinterName( PCHAR Name )
{
 //  ਭ ᮤন  OS2.ini.
 CHAR Printer_name[ SIZE_OF_PATH ] = "";
 PrfQueryProfileString( HINI_USERPROFILE, "PM_SPOOLER", "QUEUE", "", Printer_name, SIZE_OF_PATH );

 // ᫨  㧭  㤠 - .
 if( Printer_name[ 0 ] == 0 ) return;

 // ᫨ ᫥ 㪢  ਭ ";" - ⠢    ப.
 INT End_of_string = strlen( Printer_name ) - 1;
 if( Printer_name[ End_of_string ] == ';' ) Printer_name[ End_of_string ] = 0;

 //  ப.
 strcpy( Name, Krnl_Repository.Settings.Objects.Printer_prtname ); strcat( Name, Printer_name ); strcat( Name, ">" );

 // .
 return;
}

//    窠 "" 

// Name - ப  .
VOID Krnl_Repository_QueryConnectionsName( PCHAR Name )
{
 //  ப.
 strcpy( Name, Krnl_Repository.Settings.Objects.Connections_name );

 // .
 return;
}

//    窠 "" 

// Title - ப  .
VOID Krnl_Repository_QueryConnectionsTitle( PCHAR Title )
{
 CHAR Connections_name[ SIZE_OF_NAME ] = ""; Krnl_Repository_QueryConnectionsName( Connections_name );
 HOBJECT Connections_object = QueryWPSObject( Connections_name );

 if( Connections_object != NULLHANDLE )
  {
   CHAR Path[ SIZE_OF_PATH ] = ""; WinQueryObjectPath( Connections_object, Path, SIZE_OF_PATH );
   if( Path[ 0 ] != 0 ) strcpy( Title, FindNameInPath( Path ) );
  }

 // .
 return;
}
